<template>
  <v-card class="place-card d-flex pa-3 mb-2" @click="selectProject">
    <v-row>
      <v-col cols="12" md="4" order="1" class="d-flex align-center mb-3 mb-md-0">
        <div class="mr-3 mr-md-5">
          <v-img
            v-if="icon"
            class="category-icon"
            :src="require(`../assets/img/${icon}`)"
            contain
            width="45"
          />
        </div>
        <h2 class="main-text-color subtitle-1 font-weight-bold">{{name}}</h2>
      </v-col>

      <v-col cols="9" md="4" order="2" class="d-flex align-center mb-3 mb-md-0">
        <div class="d-flex flex-column main-text-color-2">
          <div class="subcategory-name subtitle-1 font-weight-bold mb-3 mb-md-0">
            Региональный проект: "{{shortSubcategory}}"
          </div>
          <div class="responsible-name subtitle-1 font-weight-regular">
            Ответственный: {{responsible}}
          </div>
        </div>
      </v-col>

      <v-col cols="12" md="3" order="12" order-md="3" class="d-flex align-center main-text-color-2">
        <div class="address subtitle-2 font-weight-regular">
          {{address}}
        </div>
      </v-col>

      <v-col cols="3" md="1" order="11" order-md="12"
             class="d-flex align-center flex-column flex-md-row justify-center justify-md-start">
        <div class="mr-md-2 mb-2 mb-md-0">
          <v-img
            :src="require('../assets/img/distance.png')"
            contain
            width="30"
          />
        </div>

        <div v-if="distance !== undefined" class="distance title font-weight-regular main-text-color-2">
          {{distanceShort}}
        </div>
      </v-col>
    </v-row>
  </v-card>
</template>
<script>
  import {mapActions} from 'vuex';

  export default {
    name: 'Place',
    props: {
      id: Number,
      name: String,
      icon: String,
      color: String,
      category: String,
      count: Number,
      contacts: String,
      subcategory: String,
      responsible: String,
      address: String,
      distance: Number,
      description: String,
      type: String,
      endDate: String,
      email: String,
      website: String,
      phone: String,
      coords: Array
    },
    computed: {
      shortSubcategory() {
        if (!this.subcategory) return '';
        return this.subcategory.length > 34 ? `${this.subcategory.substr(0, 31)}...` : this.subcategory;
      },
      distanceShort() {
        if (this.distance >= 1000) {
          const km = (this.distance / 1000).toFixed(1);
          return `${km} км`;
        }
        return `${this.distance} м`;
      },
    },
    methods: {
      ...mapActions('projects', [
        'setSelectedProject',
      ]),
      selectProject: async function() {
        await this.setSelectedProject(this.$props);
        this.$router.push(`/projects/${this.id}`);
      }
    }
  };
</script>

<style scoped>
  .subtitle-1 {
    font-size: 1.2rem !important;
    line-height: 1.25rem !important;
  }

  .place-card {
    box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.2);
    border-radius: 8px !important;
  }

  .place-card .row > div {
    padding-top: 0;
    padding-bottom: 0;
  }
</style>
